apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  name: node-scan
  namespace: ci
spec:
  params:
  - default: https://registry.npmjs.org
    description: NPMJS Repository Endpoint
    name: npmmirror
    type: string
  - default: http://sonarqube-kube.ci.svc.cluster.local:9000
    description: SonarQube Host URL
    name: sonarhost
    type: string
  - default: ""
    description: SonarQube Password
    name: sonarpassword
    type: string
  - default: Awesome Demo
    description: SonarQube Project Description
    name: sonarprojectdescription
    type: string
  - default: demo
    description: SonarQube Project Name
    name: sonarprojectname
    type: string
  - default: ""
    description: SonarQube Username
    name: sonarusername
    type: string
  resources:
    inputs:
    - name: source
      targetPath: /
      type: git
  steps:
  - args:
    - -c
    - |
      echo "Workspace check:"
      ls -al /workspace || echo no workspace
      ls -al /workspace/.git >/dev/null || echo workspace is not a git
      . /usr/local/bin/set_runtime
      SOURCE_BRANCH=`git branch 2>/dev/null | awk '{print $2}'`
      SOURCE_REPO=`git remote -v 2>/dev/null | awk '{print $2;exit 0;}'`
      SOURCE_REF=`git rev-parse HEAD 2>/dev/null`
      cat <<EOF
      Preparing to scan code ...
      REPO:   $SOURCE_REPO
      BRANCH: $SOURCE_BRANCH
      REF:    $SOURCE_REF
      EOF
      npm cache clean --force || echo WARNING: cache clean returned non-0
      if test "$(inputs.params.npmmirror)"; then
          export NPM_MIRROR=$(inputs.params.npmmirror)
      fi
      if grep ^install: Makefile >/dev/null; then
          make install
      elif test -s ./yarn.lock; then
          yarn install --network-timeout 600000
      else
          npm install --unsafe-perm
      fi
      npm install --unsafe-perm xunit-file mocha expect sonarqube-scanner mock-require
      test -d reports || mkdir -p reports
      XUNIT_FILE=reports/TESTS-xunit.xml ./node_modules/.bin/mocha -R xunit-file $(find tests -name '*.js' 2>/dev/null)
      if test "$(inputs.params.sonarpassword)" -a "$(inputs.params.sonarusername)"; then
          echo "sonar.password=$(inputs.params.sonarpassword)" >>sonar-project.properties
          echo "sonar.login=$(inputs.params.sonarusername)" >>sonar-project.properties
      fi
      echo sonar credentials not found for $(inputs.params.sonarhost), reporting anonymously
      echo "sonar.exclusions=node_modules/** docs/**" >sonar-project.properties
      echo sonar.host.url=$(inputs.params.sonarhost) >>sonar-project.properties
      echo sonar.links.homepage=$SOURCE_REPO >>sonar-project.properties
      echo sonar.links.issue=$SOURCE_REPO/issues >>sonar-project.properties
      echo sonar.projectDescription=$(inputs.params.sonarprojectdescription) >>sonar-project.properties
      echo sonar.projectKey=$(inputs.params.sonarprojectname) >>sonar-project.properties
      echo sonar.projectName=$(inputs.params.sonarprojectname) >>sonar-project.properties
      echo sonar.projectVersion=$SOURCE_BRANCH >>sonar-project.properties
      echo sonar.sources=./ >>sonar-project.properties
      if test -d test; then
          echo sonar.tests=tests >>sonar-project.properties
          echo "sonar.test.exclusions=tests/**" >>sonar-project.properties
      elif test -d test; then
          echo sonar.tests=test >>sonar-project.properties
          echo "sonar.test.exclusions=test/**" >>sonar-project.properties
      fi
      JAVA_TOOL_OPTIONS='-XX:+UnlockExperimentalVMOptions -Dsun.zip.disableMemoryMapping=true' ./node_modules/.bin/sonar-scanner || true
    command:
    - /bin/sh
    image: registry.gitlab.com/synacksynack/opsperator/docker-jenkins-agent-sonar:master
    name: build
    resources:
      limits:
        cpu: 400m
        memory: 4Gi
      requests:
        cpu: 200m
        memory: 2Gi
    securityContext:
      privileged: true
      runAsUser: 0
